Imports System
Imports System.IO.Ports

Module main

    Sub Main()

        ' Read command from console
        Console.Write("Command: ")
        Dim cmd As String = Console.ReadLine()

        Dim sp As SerialPort = New SerialPort()

        ' COM port parameters
        sp.PortName = "COM5"
        sp.BaudRate = 115200
        sp.DataBits = 8
        sp.Parity = Parity.None
        sp.StopBits = StopBits.One

        ' RTS/CTS handshaking
        sp.Handshake = Handshake.RequestToSend
        sp.DtrEnable = True

        ' Error handling
        sp.DiscardNull = False
        sp.ParityReplace = 0


        Try

            sp.Open()

            ' Append CR+LF to input and write to port
            sp.Write(cmd + ControlChars.CrLf)

            Dim lastRead As DateTime = DateTime.Now
            Dim elapsedTime As TimeSpan = New TimeSpan()

            ' 2 second timespan
            Dim TIMEOUT As TimeSpan = New TimeSpan(0, 0, 2)

            ' Read from port until TIMEOUT time has elapsed since
            ' last successful read
            While TIMEOUT.CompareTo(elapsedTime) > 0

                Dim buffer As String = sp.ReadExisting()

                If buffer.Length > 0 Then

                    Console.Write(buffer)
                    lastRead = DateTime.Now

                End If

                elapsedTime = DateTime.Now - lastRead

            End While

            sp.Close()

        Catch e As Exception

            System.Console.Write(e.Message)

        End Try

    End Sub

End Module
